diff -ruN uppsrc/CtrlLib/MenuBar.cpp uppsrc/CtrlLib/MenuBar.cpp
--- uppsrc/CtrlLib/MenuBar.cpp	2012-09-29 21:48:32 +0400
+++ uppsrc/CtrlLib/MenuBar.cpp	2012-10-04 11:43:09 +0400
@@ -50,6 +50,23 @@
 	pullshift.y = -1;
 }
 
+class MenuBarEntity : public Moveable<MenuBarEntity> {
+private:
+	MenuBar *menu;
+public:
+	MenuBarEntity() : menu(NULL) { }
+	~MenuBarEntity() {
+		if(menu) {
+			LLOG("MenuBarEntity: CloseMenu");
+			menu->CloseMenu();
+		}
+	}
+	void ClearMenu()             { menu = NULL; }
+	void SetMenu(MenuBar *bar)   { menu = bar; }
+};
+
+static One<MenuBarEntity> mbe;
+
 MenuBar::MenuBar()
 {
 	LLOG("MenuBar " << Name());
@@ -556,15 +573,11 @@
 
 void MenuBar::Execute(Ctrl *owner, Point p)
 {
-	static Vector<Ctrl *> ows; // Used to prevent another open local menu for single owner to be opened (repeated right-click)
-	int level = ows.GetCount();
-	if(IsEmpty() || FindIndex(ows, owner) >= 0)
+	if(IsEmpty())
 		return;
-	ows.Add(owner);
+	mbe.Create().SetMenu(this);
 	PopUp(owner, p);
 	EventLoop(this);
-	CloseMenu();
-	ows.SetCount(level);
 }
 
 void MenuBar::Execute(Ctrl *owner, Callback1<Bar&> proc, Point p)
@@ -591,6 +604,8 @@
 	if(parentmenu)
 		parentmenu->SetActiveSubmenu(NULL, NULL);
 	LLOG("~MenuBar 1");
+	if(!mbe.IsEmpty())
+		mbe.Clear();
 }
 
 END_UPP_NAMESPACE
